<?xml version="1.0"?>

<tradingsystem>

<title>
	Force Index System No.1 (Automatic 4)
</title>

<description>
	&lt;b&gt;Name:&lt;br&gt;
	&lt;/b&gt;Force Index System No.1 (Automatic 4)&lt;b&gt;&lt;br&gt;
	Trading System Information:&lt;/b&gt;&lt;br&gt;
	The Force Index was developed by Dr. Alexander Elder. This trading system uses the measurement of the power of buyers and sellers to generate trading signals.
	the idea behind: Elder says that the prices of the shares reflect the thoughts of the traders and the conversions their feelings.&lt;br&gt;
	&lt;a href="http://www.webotron.com/box/redirect.php?url=14" target="webotron"&gt;External Informations&lt;/a&gt;&lt;br&gt;
	&lt;b&gt;Kind of System:&lt;/b&gt;&lt;br&gt;
	Automatic Trading System (Automatically searches the best fitting values for this system)&lt;br&gt;
</description>

<initialisation>

    global gArrayDate, gArrayOpen, gArrayHigh, gArrayLow, gArrayClose, gArrayVolume
    global gTradingResultArray, gchangeperiod
    global gSymbolName, gSymbolNameExpl, gTraSysInfos, gExplResults
    global gSignalCleaner, gCurrentTradingSystemName
    global gTradingSystemsArray, gReportGenerating, gAutSysNewCalc
    global gDataLenght, gLastDataLenght

	on new (me, theExtra)

	gTradingResultArray = []

	if gchangeperiod = "daily" then
    	theperiod = "d"
  	else if gchangeperiod = "weekly" then
    	theperiod = "w"
  	else if gchangeperiod = "intraday" then
    	theperiod = "d"
  	end if
	-- DEFAULT TRADING SYSTEM PREFERENCES
	systemArrays = getTradingSystemPrefs("0")
</initialisation>

<calculation>

	prefFileName = findAndReplaceAll(gCurrentTradingSystemName, ".s", "")
	-- GET TRADING SYSTEM VALUES FROM PREFERENCES OR CREATE PREFERENCES FILE
	indPrefsArray = value(getPref(prefFileName &amp; "_" &amp; theperiod))
	if indPrefsArray = VOID or indPrefsArray = empty then
		setPref(prefFileName &amp; "_" &amp; theperiod, "[:]")
		indPrefsArray = value(getPref(prefFileName &amp; "_" &amp; theperiod))
	end if

	if gReportGenerating = 0 then
		currentSymbolName = gSymbolName
	else
		currentSymbolName = gSymbolNameExpl
	end if
	if currentSymbolName = VOID then currentSymbolName = gSymbolName
	-- alert string(gSymbolNameExpl)
	-- KEINE SYSTEM PREFS VORHANDEN ODER SYSTEM NEU BERECHNEN
	if indPrefsArray.findPos(currentSymbolName) = VOID or the KeyPressed = SPACE or gAutSysNewCalc = 1 then

	--

	-- GENERATE VALUES ARRAY
	-- OVERSOLD ARRAY
	aArray = [3,5,8,13,14,21,34,55]
	bArray = [1,2,3,4,5]
	-- MAIN ARRAY
	ArrayValues = []
	-- ARRAY CALCULATION
	repeat with a in aArray
		repeat with b in bArray
			ArrayTMP = []
			add ArrayTMP, a
			add ArrayTMP, b
			add ArrayValues, ArrayTMP
		end repeat
	end repeat
	--
	-- alert string(ArrayValues.count)
	allSysArray = []

	--

	-- abdunkeln
	if gReportGenerating = 0 then
		darkup(1)
		factor100 = (100.000/float(ArrayValues.count))
		-- prozent window einblenden
  		member("percentdone1").text = "Working ..."
  		sprite(101).visible = true
  		sprite(102).visible = true
  		sprite(103).visible = true
  		updatestage
  	end if

	--

	repeat with values in ArrayValues

	if gReportGenerating = 0 then
		-- stop pressing
		if cancelPressed() then
			stopIt = 1
  			exit repeat
		end if
	end if

		gTradingResultArray = []
		opt1 = values[1]
		opt2 = values[2]

		-- OLD SYSTEM START ----------------
		------------------------------------
		-- CALCULATES RSI ARRAY
		FORCE = FORCE(me, opt1)
		--
		add gTradingResultArray, 0
		repeat with counter = 2 to gArrayClose.count
    		--
    		-- START SYSTEM
    		--
    		if counter &gt; 1 then
    			-- RSI LEAVES OVERSOLD AREA
    			if FORCE[counter] &gt;= 0 and FORCE[counter-1] &lt;= 0 then
    				add gTradingResultArray, 1
    			-- RSI LEAVES OVERBOUGHT AREA
    			else if FORCE[counter] &lt;= 0 and FORCE[counter-1] &gt;= 0 then
    				add gTradingResultArray, 2
    			else
    				add gTradingResultArray, 0
    			end if
    		else
    			add gTradingResultArray, 0
    		end if
    		--
    		-- END SYSTEM
    		--
		end repeat

		-- STOPS
		stopsArray = value("[[0,0],[0,0],[0,1],[0,0],[0,0],[0,0],[0,0],[0,0]]")
		stopsArray[3][1] = opt2
		gTradingResultArray = STOPS(me, stopsArray, gTradingResultArray)

		------------------------------------
		-- OLD SYSTEM END ------------------

		-- BACKTEST PERIOD CHANGE IF NECCESSARY
		gTradingResultArray = changeBacktestPeriod(gTradingResultArray)

		-- ADD THIS TRADINGSYSTEM TO ALL RESULTS ARRAY
		oneSysArray = []
    	add oneSysArray, miniSystemBacktest(gTradingResultArray)
    	add oneSysArray, opt1
    	add oneSysArray, opt2
    	add oneSysArray, gTradingResultArray
    	add allSysArray, oneSysArray

    	if gReportGenerating = 0 then
    		calcCount = calcCount + 1
    		member("percentdone1").text = string(round(calcCount * factor100)) &amp; "% done"
    	end if

	end repeat

	-- BEI ABBRUCH KEINE BACKTESTS DURCHFUEHREN
	if stopIt then
		nothing
	else

	-- GET BEST SYSTEM
    sort allSysArray
    repeat with j = allSysArray.count down to 1
    	if allSysArray[j][1] &lt;&gt; VOID and allSysArray[j][1] &lt;&gt; "" and allSysArray[j][1] &lt;&gt; 0 then
    		-- HIGHEST WINNER = TRADING SYSTEM
    		gTradingResultArray = allSysArray[j][4]
    		exit repeat
    	end if
    end repeat

    ----------------------------------
    -- FUER TRADING SYSTEM INFO
    ----------------------------------
    opt1 = allSysArray[allSysArray.count][2]
    opt2 = allSysArray[allSysArray.count][3]
    ----------------------------------

    -- SAVE PREFERENCES
    ArrayTMP = []
    	add ArrayTMP, allSysArray[allSysArray.count][2]
    	add ArrayTMP, allSysArray[allSysArray.count][3]
    if indPrefsArray.findPos(currentSymbolName) = VOID then
    	addProp(indPrefsArray, currentSymbolName, ArrayTMP)
    else
    	indPrefsArray[currentSymbolName] = ArrayTMP
    end if
    setPref prefFileName &amp; "_" &amp; theperiod, string(indPrefsArray)

    end if

    --

    if gReportGenerating = 0 then
    	-- aufhellen
    	sprite(101).visible = false
  		sprite(102).visible = false
  		sprite(103).visible = false
  		updatestage
    	darkup(0)
    end if

    --

    else
    -- SYSTEM AUS PREFS BERECHNEN
    prefValueArray = indPrefsArray.getProp(currentSymbolName)
    opt1 = prefValueArray[1]
    opt2 = prefValueArray[2]

    	-- OLD SYSTEM START ----------------
		------------------------------------
		-- CALCULATES RSI ARRAY
		FORCE = FORCE(me, opt1)
		--
		add gTradingResultArray, 0
		repeat with counter = 2 to gArrayClose.count
    		--
    		-- START SYSTEM
    		--
    		if counter &gt; 1 then
    			-- RSI LEAVES OVERSOLD AREA
    			if FORCE[counter] &gt;= 0 and FORCE[counter-1] &lt;= 0 then
    				add gTradingResultArray, 1
    			-- RSI LEAVES OVERBOUGHT AREA
    			else if FORCE[counter] &lt;= 0 and FORCE[counter-1] &gt;= 0 then
    				add gTradingResultArray, 2
    			else
    				add gTradingResultArray, 0
    			end if
    		else
    			add gTradingResultArray, 0
    		end if
    		--
    		-- END SYSTEM
    		--
		end repeat

		-- STOPS
		stopsArray = value("[[0,0],[0,0],[0,1],[0,0],[0,0],[0,0],[0,0],[0,0]]")
		stopsArray[3][1] = opt2
		gTradingResultArray = STOPS(me, stopsArray, gTradingResultArray)

		------------------------------------
		-- OLD SYSTEM END ------------------

		-- BACKTEST PERIOD CHANGE IF NECCESSARY
		gTradingResultArray = changeBacktestPeriod(gTradingResultArray)

	end if

	--------------------------------------------
	-- TRADING SYSTEM INFORMATIONS
	--------------------------------------------
	gTraSysInfos = []
	add gTraSysInfos, value(["RSI Value:",opt1])
	add gTraSysInfos, value(["Stop Lose %:",opt2])
	add gTraSysInfos, value(["Oversold Line:",30])
	add gTraSysInfos, value(["Overbought Line:",70])
	add gTraSysInfos, value(["Bars Exit %:","--"])

	theBackTest = systemBacktest (gTradingResultArray)
	member("backtestpercents").text = string(theBackTest[15]) &amp;&amp; "%"

	if gExplResults &lt;&gt; void then add gExplResults, systemBacktest (gTradingResultArray, gSymbolNameExpl)

	end
</calculation>

</tradingsystem>
