<?xml version="1.0"?>

<tradingsystem>

<title>
	Relative Strenght by Levy System No.1
</title>

<description>
	&lt;b&gt;Name:&lt;br&gt;
	&lt;/b&gt;Relative Strenght by Levy System No.1&lt;b&gt;&lt;br&gt;
	Trading System Information:&lt;/b&gt;&lt;br&gt;
	The RSL (Relative Strenght by Levy) compares the performance of the security against the performance of the same security half a year ago.&lt;br&gt;
	&lt;a href="http://www.web-o-tron.com/school/tradingsystems/rsl.php" target="webotron"&gt;External Informations&lt;/a&gt;&lt;br&gt;
	&lt;b&gt;Kind of System:&lt;/b&gt;&lt;br&gt;
	Mechanical Trading System&lt;br&gt;
</description>

<initialisation>

    global gArrayDate, gArrayOpen, gArrayHigh, gArrayLow, gArrayClose, gArrayVolume
    global gTradingResultArray, gchangeperiod
    global gSymbolName, gSymbolNameExpl, gTraSysInfos, gExplResults
    global gSignalCleaner, gCurrentTradingSystemName
    global gTradingSystemsArray, gReportGenerating, gAutSysNewCalc
    global gDataLenght, gLastDataLenght

	on new (me, theExtra)

	gTradingResultArray = []

	if gchangeperiod = "daily" then
    	theperiod = "d"
  	else if gchangeperiod = "weekly" then
    	theperiod = "w"
  	else if gchangeperiod = "intraday" then
    	theperiod = "d"
  	end if
	-- DEFAULT TRADING SYSTEM PREFERENCES
	systemArrays = getTradingSystemPrefs([[["Direction Check Value:",3]],[[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0]]], theperiod)
	--
	-- Momentum VALUE
	opt1 = systemArrays[1][1][2]
</initialisation>

<calculation>
	if gchangeperiod = "daily" then
    	SMA135 = MAs(me, gArrayClose, 135)
  	else if gchangeperiod = "weekly" then
    	SMA135 = MAs(me, gArrayClose, 27)
  	else if gchangeperiod = "intraday" then
    	SMA135 = MAs(me, gArrayClose, 135)
  	end if
  	
  	newArray = []
  	repeat with counter = 1 to gArrayClose.count
  		add newArray,  (gArrayClose[counter] / SMA135[counter])
  	end repeat
  	theDirection = DIRECTION(me, newArray, opt1)
	--
	add gTradingResultArray, 0
	repeat with counter = 2 to gArrayClose.count
    	--
    	-- START SYSTEM
    	--
    	-- MOM CROSSES 100
    	if theDirection[counter - 1] &lt; theDirection[counter] and theDirection[counter] &gt; 1 then
    		add gTradingResultArray, 1
    	-- MOM CROSSES 100
    	else if theDirection[counter - 1] &gt; theDirection[counter] and theDirection[counter] &lt; 1 then
    		add gTradingResultArray, 2
    	else
    		add gTradingResultArray, 0
    	end if
    	--
    	-- END SYSTEM
    	--
	end repeat
	--
	-- STOPS AND CLEANER
	gOldTradingResultArray = gTradingResultArray
	gTradingResultArray = STOPS(me, systemArrays[2], gTradingResultArray)
	if gSignalCleaner = 0 then
		gTradingResultArray = SIGNALCLEANER(me, gTradingResultArray, gOldTradingResultArray)
	end if
	
	-- BACKTEST PERIOD CHANGE IF NECCESSARY
	gTradingResultArray = changeBacktestPeriod(gTradingResultArray)
	
	--------------------------------------------
	-- TRADING SYSTEM INFORMATIONS
	--------------------------------------------
	gTraSysInfos = []
	add gTraSysInfos, value(["Direction Check Value:",opt1])
	if systemArrays[2][1][2] = 1 then
		add gTraSysInfos, value(["Stop Lose %:",systemArrays[2][1][1]])
	else
		add gTraSysInfos, value(["Stop Lose %:","--"])
	end if
	if systemArrays[2][2][2] = 1 then
		add gTraSysInfos, value(["Profit Exit %:",systemArrays[2][2][1]])
	else
		add gTraSysInfos, value(["Profit Exit %:","--"])
	end if
	if systemArrays[2][3][2] = 1 then
		add gTraSysInfos, value(["Bars Exit %:",systemArrays[2][3][1]])
	else
		add gTraSysInfos, value(["Bars Exit %:","--"])
	end if
	
theBackTest = systemBacktest (gTradingResultArray)
	member("backtestpercents").text = string(theBackTest[15]) &amp;&amp; "%"

	if gExplResults &lt;&gt; void then add gExplResults, systemBacktest (gTradingResultArray, gSymbolNameExpl)

	end
</calculation>

</tradingsystem>
