<?xml version="1.0"?>

<tradingsystem>

<title>
	Stochastic System No.1
</title>

<description>
	&lt;b&gt;Name:&lt;br&gt;
	&lt;/b&gt;Stochastic System No.1&lt;b&gt;&lt;br&gt;
	Trading System Information:&lt;/b&gt;&lt;br&gt;
	The Stochastic Oszillator was developed by George C. Lane. We use it to find overbought and oversold levels.&lt;br&gt;
	&lt;a href="http://www.web-o-tron.com/school/tradingsystems/stochastic.php" target="webotron"&gt;External Informations&lt;/a&gt;&lt;br&gt;
	&lt;b&gt;Kind of System:&lt;/b&gt;&lt;br&gt;
	Mechanical Trading System&lt;br&gt;
</description>

<initialisation>

    global gArrayDate, gArrayOpen, gArrayHigh, gArrayLow, gArrayClose, gArrayVolume
    global gTradingResultArray, gchangeperiod
    global gSymbolName, gSymbolNameExpl, gTraSysInfos, gExplResults
    global gSignalCleaner, gCurrentTradingSystemName
    global gTradingSystemsArray, gReportGenerating, gAutSysNewCalc
    global gDataLenght, gLastDataLenght

	on new (me, theExtra)

	gTradingResultArray = []

	if gchangeperiod = "daily" then
    	theperiod = "d"
  	else if gchangeperiod = "weekly" then
    	theperiod = "w"
  	else if gchangeperiod = "intraday" then
    	theperiod = "d"
  	end if
	-- DEFAULT TRADING SYSTEM PREFERENCES
	systemArrays = getTradingSystemPrefs([[["Stochastic Value 1:",5],["Stochastic Value 2:",3]],[[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0]]], theperiod)
	--
	-- macd l
	opt1 = systemArrays[1][1][2]
	-- macd s
	opt2 = systemArrays[1][2][2]
</initialisation>

<calculation>
	-- CALCULATES MOM ARRAY
	STOCH = STOCHSLOW(me, opt1, opt2)
	--
	add gTradingResultArray, 0
	repeat with counter = 2 to gArrayClose.count
    	--
    	-- START SYSTEM
    	--
    	-- MOM CROSSES 100
    	if STOCH[counter] &gt;= 30 and STOCH[counter - 1] &lt;= 30 then
    		add gTradingResultArray, 1
    	-- MOM CROSSES 100
    	else if STOCH[counter] &lt;= 70 and STOCH[counter - 1] &gt;= 70 then
    		add gTradingResultArray, 2
    	else
    		add gTradingResultArray, 0
    	end if
    	--
    	-- END SYSTEM
    	--
	end repeat
	--
	-- STOPS AND CLEANER
	gOldTradingResultArray = gTradingResultArray
	gTradingResultArray = STOPS(me, systemArrays[2], gTradingResultArray)
	if gSignalCleaner = 0 then
		gTradingResultArray = SIGNALCLEANER(me, gTradingResultArray, gOldTradingResultArray)
	end if
	
	-- BACKTEST PERIOD CHANGE IF NECCESSARY
	gTradingResultArray = changeBacktestPeriod(gTradingResultArray)
	
	--------------------------------------------
	-- TRADING SYSTEM INFORMATIONS
	--------------------------------------------
	gTraSysInfos = []
	add gTraSysInfos, value(["Stochastic Value 1:",opt1])
	add gTraSysInfos, value(["Stochastic Value 2:",opt2])
	add gTraSysInfos, value(["Overbought Line:",70])
	add gTraSysInfos, value(["Oversold Line:",30])
	if systemArrays[2][1][2] = 1 then
		add gTraSysInfos, value(["Stop Lose %:",systemArrays[2][1][1]])
	else
		add gTraSysInfos, value(["Stop Lose %:","--"])
	end if
	if systemArrays[2][2][2] = 1 then
		add gTraSysInfos, value(["Profit Exit %:",systemArrays[2][2][1]])
	else
		add gTraSysInfos, value(["Profit Exit %:","--"])
	end if
	if systemArrays[2][3][2] = 1 then
		add gTraSysInfos, value(["Bars Exit %:",systemArrays[2][3][1]])
	else
		add gTraSysInfos, value(["Bars Exit %:","--"])
	end if
theBackTest = systemBacktest (gTradingResultArray)
	member("backtestpercents").text = string(theBackTest[15]) &amp;&amp; "%"

	if gExplResults &lt;&gt; void then add gExplResults, systemBacktest (gTradingResultArray, gSymbolNameExpl)

	end
</calculation>

</tradingsystem>
